function love.load()
  love.window.setTitle("Alarm Clock with Math Problem")
  love.mouse.setVisible(false)
  love.window.setMode(0,0)
	time = nil
  sec = 0
  min = 0
  hour = 0
  daytime = "AM"
  upar = love.graphics.newImage("assets/images/uparrow.png")
  dnar = love.graphics.newImage("assets/images/downarrow.png")
  upar2 = love.graphics.newImage("assets/images/uparrow2.png")
  dnar2 = love.graphics.newImage("assets/images/downarrow2.png")
  tog = love.graphics.newImage("assets/images/toggle.png")
  alarmSFX = love.audio.newSource("assets/sounds/alarm.wav")
  alhr = 7
  has0 = true
  almn = 0
  aldt = "AM"
  setalarm = "NONE"
  ahour = 99
  amin = 99
  adaytime = "PM"
  active = false
  n1 = love.math.random(1,999)
  n2 = love.math.random(1,999)
  ans = n1 + n2
  yourans = ""
  inc = false
  love.graphics.setDefaultFilter("nearest","nearest")
end

function love.keypressed(key)
	if key == "end" then
    love.event.quit()
  elseif key == "kp+" and active == false then
    if aldt == "AM" then
      aldt = "PM"
    else
      aldt = "AM"
    end
  elseif key == "kp8" and active == false then
    alhr = alhr + 1
    if alhr > 12 then
      alhr = 1
    end
    if alhr >= 1 and alhr <= 9 then
      has0 = true
    elseif alhr >= 10 and alhr <= 12 then
      has0 = false
    end
  elseif key == "kp2" and active == false then
    alhr = alhr - 1
    if alhr < 1 then
      alhr = 12
    end
    if alhr >= 1 and alhr <= 9 then
      has0 = true
    elseif alhr >= 10 and alhr <= 12 then
      has0 = false
    end
  elseif key == "kp6" and active == false then
    almn = almn + 1
    if almn > 59 then
      almn = 0
    end
  elseif key == "kp4" and active == false then
    almn = almn - 1
    if almn < 0 then
      almn = 59
    end
  elseif key == "kpenter" and active == false then
    if has0 == true then
      setalarm = tostring(alhr):sub(2)..":"..almn.." "..aldt
    else
      setalarm = alhr..":"..almn.." "..aldt
    end
    ahour = alhr
    amin = almn
    adaytime = aldt
  elseif key == "kp0" or key == "kp1" or key == "kp2" or key == "kp3" or key == "kp4" or key == "kp5" or key == "kp6" or key == "kp7" or key == "kp8" or key == "kp9" then
    if active == true then
      yourans = yourans..(key:sub(3))
    end
  elseif key == "kp." and active == true then
    yourans = ""
  elseif key == "kpenter" and active == true then
    if tonumber(yourans) == ans then
      ahour = 99
      amin = 99
      n1 = love.math.random(1,999)
      n2 = love.math.random(1,999)
      ans = n1 + n2
      yourans = ""
      inc = false
      active = false
      love.audio.stop(alarmSFX)
    else
      inc = true
      yourans = ""
    end
  end
end

function love.update(dt)
  if tonumber(ahour) == tonumber(hour) and tonumber(amin) == tonumber(min) and adaytime == daytime then
    active = true
  end
  if active == true then
    love.audio.play(alarmSFX)
  end
end

function love.draw()
  love.graphics.setBackgroundColor(63,204,63)
  time = os.date("*t")
  if time.hour >= 0 and time.hour <= 11 then
    daytime = "AM"
	hour = time.hour
  elseif time.hour == 12 then
    daytime = "PM"
	hour = time.hour
  elseif time.hour >= 13 and time.hour < 23 then
    daytime = "PM"
	hour = time.hour - 12
  end
  if string.len(tostring(time.min)) == 1 then
    min = "0"..time.min
  else
    min = time.min
  end
  if string.len(tostring(time.sec)) == 1 then
    sec = "0"..time.sec
  else
    sec = time.sec
  end
  if string.len(tostring(almn)) == 1 then
    almn = "0"..almn
  else
    almn = almn
  end
  if string.len(tostring(alhr)) == 1 then
    alhr = "0"..alhr
  else
    alhr = alhr
  end
  if active == false then
    love.graphics.print("Time: "..hour..":"..min..":"..sec.." "..daytime,15,15,0,2,2)
    love.graphics.print("Alarm: "..setalarm,15,45,0,2,2)
    love.graphics.print(os.date("Today is %A, %B %d, %Y"),15,75,0,2,2)
    love.graphics.print("Please select a time for the alarm to go off:",15,105,0,2,2)
    love.graphics.print("Once your alarm is set, hit Enter",15,135,0,2,2)
    love.graphics.draw(upar,15,205)
    love.graphics.print(alhr,115,215,0,2,2)
    love.graphics.draw(dnar,195,205)
    love.graphics.draw(upar2,15,305)
    love.graphics.print(almn,115,315,0,2,2)
    love.graphics.draw(dnar2,195,305)
    love.graphics.print(aldt,65,415,0,2,2)
    love.graphics.draw(tog,155,405)
  else
    love.graphics.print("Please solve this math problem:",15,15,0,2,2)
    love.graphics.print("Press Enter to check answer, Del to clear answer",15,45,0,2,2)
    love.graphics.print(n1.." + "..n2.." = ?",15,75,0,2,2)
    love.graphics.print("Your answer: "..yourans,15,105,0,2,2)
    if inc == true then
      love.graphics.print("INCORRECT",15,135,0,2,2)
    end
  end
end